// CoorToolsDoc.cpp : implementation of the CCoorToolsDoc class
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgGeoSol.h"
#include "CoorToolsDoc.h"
#include "DlgGaussProjection.h"
#include "DlgGaussChangeZone.h"
#include "DlgPlanexySA.h"
#include "DlgCalPara3D.h"
#include "DlgCoordTrans3D.h"
#include "DlgCoordTrans3D.h"
#include "DlgCalPara2D.h"
#include "DlgCoordTrans2D.h"
#include "dlgsphere.h"
#include "dlgblhxyz.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCoorToolsDoc

IMPLEMENT_DYNCREATE(CCoorToolsDoc, CDocument)

BEGIN_MESSAGE_MAP(CCoorToolsDoc, CDocument)
	//{{AFX_MSG_MAP(CCoorToolsDoc)
	ON_COMMAND(ID_SET_PARAMETER, OnSetParameter)
	ON_COMMAND(ID_BLH_XYZ, OnBlhXyz)
	ON_COMMAND(ID_MENUITEM_GeoSol, OnMENUITEMGeoSol)
	ON_COMMAND(ID_MENUITEM_GaussProjection, OnMENUITEMGaussProjection)
	ON_COMMAND(ID_MENUITEM_GaussChangeZone, OnMENUITEMGaussChangeZone)
	ON_COMMAND(ID_MENUITEM_PlanexySA, OnMENUITEMPlanexySA)
	ON_COMMAND(ID_MENU_CalPara_3D, OnMENUCalPara3D)
	ON_COMMAND(ID_MENU_CoordTrans3D, OnMENUCoordTrans3D)
	ON_COMMAND(ID_MENU_CalPara2D, OnMENUCalPara2D)
	ON_COMMAND(ID_MENU_CoordTrans2D, OnMENUCoordTrans2D)
	ON_UPDATE_COMMAND_UI(ID_BLH_XYZ, OnUpdateBlhXyz)
	ON_UPDATE_COMMAND_UI(ID_MENU_CoordTrans2D, OnUpdateMENUCoordTrans2D)
	ON_UPDATE_COMMAND_UI(ID_MENU_CoordTrans3D, OnUpdateMENUCoordTrans3D)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_GaussChangeZone, OnUpdateMENUITEMGaussChangeZone)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_GaussProjection, OnUpdateMENUITEMGaussProjection)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_GeoSol, OnUpdateMENUITEMGeoSol)
	ON_UPDATE_COMMAND_UI(ID_MENUITEM_PlanexySA, OnUpdateMENUITEMPlanexySA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoorToolsDoc construction/destruction

CCoorToolsDoc::CCoorToolsDoc()
{
	m_csVersion.Format("1.0");

	m_iCurrentOperation=-1;

	m_csCurrentOperation="";

	m_AngleTypeIn=1,m_AngleTypeOut=1;

	m_bRegisterd=((CCoorToolsApp*)AfxGetApp())->m_bRegisterd;
}

CCoorToolsDoc::~CCoorToolsDoc()
{
}

BOOL CCoorToolsDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCoorToolsDoc serialization

void CCoorToolsDoc::Serialize(CArchive& ar)
{
	int i;
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar.WriteString("CoorTools\r\n");
		ar.WriteString(m_csVersion+"\r\n");
		ar<<m_iCurrentOperation;
		ar<<m_csCurrentOperation;

		ar<<m_AngleTypeIn<<m_AngleTypeOut;

		for(i=0;i<7;i++)
		{
			ar<<m_Para3D[i];
		}
		for(i=0;i<4;i++)
		{
			ar<<m_Para2D[i];
		}
	}
	else
	{
		// TODO: add loading code here
		CString cstmp;
		ar.ReadString(cstmp);
		if(cstmp.CompareNoCase("CoorTools") != 0)
		{
			AfxMessageBox("It's not the file type for CoorTools!");
			return;
		}
		ar.ReadString(cstmp);

		ar>>m_iCurrentOperation;
		ar>>m_csCurrentOperation;

		ar>>m_AngleTypeIn>>m_AngleTypeOut;

		for(i=0;i<7;i++)
		{
			ar>>m_Para3D[i];
		}
		for(i=0;i<4;i++)
		{
			ar>>m_Para2D[i];
		}
	}
	m_Sphere.Serialize(ar);

}

/////////////////////////////////////////////////////////////////////////////
// CCoorToolsDoc diagnostics

#ifdef _DEBUG
void CCoorToolsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCoorToolsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCoorToolsDoc commands

void CCoorToolsDoc::OnSetParameter() 
{
	CDlgSphere dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleTypeIn;
	dlg.m_AngleOut=m_AngleTypeOut;
	if(dlg.DoModal() != IDOK) return;
	m_Sphere=dlg.m_Sphere;
	m_AngleTypeIn=dlg.m_AngleIn;
	m_AngleTypeOut=dlg.m_AngleOut;

	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleTypeIn);
	csAngleTypeOut=GetCsAngleType(m_AngleTypeOut);
	m_csCurrentOperation.Format("ã%s,Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);

	SetModifiedFlag();

	UpdateAllViews(NULL);

}

void CCoorToolsDoc::OnBlhXyz() 
{

	CDlgBLHXYZ dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleTypeIn;
	dlg.m_AngleOut=m_AngleTypeOut;
	if(dlg.DoModal() != IDOK) return;
//	ShellExecute(AfxGetMainWnd()->m_hWnd,"open",csFileName,NULL,NULL,SW_SHOWNORMAL);
//	this->m_csCurrentOperation.Format("BLH->XYZת888888");

	UpdateAllViews(NULL);
}

void CCoorToolsDoc::OnMENUITEMGeoSol() 
{
 	// TODO: Add your command handler code here
	CDlgGeoSol dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleTypeIn;
	dlg.m_AngleOut=m_AngleTypeOut;
	if(dlg.DoModal() != IDOK) return;

	UpdateAllViews(NULL);
	
}

void CCoorToolsDoc::OnMENUITEMGaussProjection() 
{
 	// TODO: Add your command handler code here
	CDlgGaussProjection dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleTypeIn;
	dlg.m_AngleOut=m_AngleTypeOut;
	if(dlg.DoModal() != IDOK) return;

	UpdateAllViews(NULL);
}

void CCoorToolsDoc::OnMENUITEMGaussChangeZone() 
{
 	// TODO: Add your command handler code here
	CDlgGaussChangeZone dlg;
	dlg.m_Sphere=m_Sphere;
	if(dlg.DoModal() != IDOK) return;
//	ShellExecute(AfxGetMainWnd()->m_hWnd,"open",csFileName,NULL,NULL,SW_SHOWNORMAL);
//	this->m_csCurrentOperation.Format("BLH->XYZת888888");

	UpdateAllViews(NULL);
	
}

void CCoorToolsDoc::OnMENUITEMPlanexySA() 
{
 	// TODO: Add your command handler code here
	CDlgPlanexySA dlg;
	dlg.m_AngleIn=m_AngleTypeIn;
	dlg.m_AngleOut=m_AngleTypeOut;
	if(dlg.DoModal() != IDOK) return;
	UpdateAllViews(NULL);
	
}

void CCoorToolsDoc::OnMENUCalPara3D() 
{
	// TODO: Add your command handler code here
	CDlgCalPara3D dlg;
	if(dlg.DoModal() != IDOK) return;
	UpdateAllViews(NULL);
	
}

void CCoorToolsDoc::OnMENUCoordTrans3D() 
{
 	// TODO: Add your command handler code here
	CDlgCoordTrans3D dlg;
	if(dlg.DoModal() != IDOK) return;
	UpdateAllViews(NULL);

}

void CCoorToolsDoc::OnMENUCalPara2D() 
{
	// TODO: Add your command handler code here
	CDlgCalPara2D dlg;
	if(dlg.DoModal() != IDOK) return;
	UpdateAllViews(NULL);
	
}

void CCoorToolsDoc::OnMENUCoordTrans2D() 
{
 	// TODO: Add your command handler code here
	CDlgCoordTrans2D dlg;
	if(dlg.DoModal() != IDOK) return;
	UpdateAllViews(NULL);
	
}

void CCoorToolsDoc::OnUpdateBlhXyz(CCmdUI* pCmdUI) 
{

	pCmdUI->Enable(m_bRegisterd);
	
}

void CCoorToolsDoc::OnUpdateMENUCoordTrans2D(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRegisterd);
	
}

void CCoorToolsDoc::OnUpdateMENUCoordTrans3D(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRegisterd);
	
}

void CCoorToolsDoc::OnUpdateMENUITEMGaussChangeZone(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRegisterd);
	
}

void CCoorToolsDoc::OnUpdateMENUITEMGaussProjection(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRegisterd);
	
}

void CCoorToolsDoc::OnUpdateMENUITEMGeoSol(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRegisterd);
	
}

void CCoorToolsDoc::OnUpdateMENUITEMPlanexySA(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRegisterd);
	
}
