// CoorToolsDoc.h : interface of the CCoorToolsDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COORTOOLSDOC_H__D0633FD3_0EE1_4F28_ABF5_C6CA5952469A__INCLUDED_)
#define AFX_COORTOOLSDOC_H__D0633FD3_0EE1_4F28_ABF5_C6CA5952469A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "geoglobal.h"

class CCoorToolsDoc : public CDocument
{
protected: // create from serialization only
	CCoorToolsDoc();
	DECLARE_DYNCREATE(CCoorToolsDoc)

// Attributes
public:
	CString m_csVersion;

	int m_iCurrentOperation;
	CString m_csCurrentOperation;

	CSphere m_Sphere;
	int m_AngleTypeIn,m_AngleTypeOut;

	BOOL m_bRegisterd;
	double m_Para3D[7];
	double m_Para2D[4];
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCoorToolsDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCoorToolsDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCoorToolsDoc)
	afx_msg void OnSetParameter();
	afx_msg void OnBlhXyz();
	afx_msg void OnMENUITEMGeoSol();
	afx_msg void OnMENUITEMGaussProjection();
	afx_msg void OnMENUITEMGaussChangeZone();
	afx_msg void OnMENUITEMPlanexySA();
	afx_msg void OnMENUCalPara3D();
	afx_msg void OnMENUCoordTrans3D();
	afx_msg void OnMENUCalPara2D();
	afx_msg void OnMENUCoordTrans2D();
	afx_msg void OnUpdateBlhXyz(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUCoordTrans2D(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUCoordTrans3D(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUITEMGaussChangeZone(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUITEMGaussProjection(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUITEMGeoSol(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMENUITEMPlanexySA(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COORTOOLSDOC_H__D0633FD3_0EE1_4F28_ABF5_C6CA5952469A__INCLUDED_)
