// DlgBLHXYZ.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgBLHXYZ.h"
#include "DlgSphere.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgBLHXYZ dialog


CDlgBLHXYZ::CDlgBLHXYZ(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgBLHXYZ::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgBLHXYZ)
	m_csParameters = _T("");
	m_B = 0.0;
	m_L = 0.0;
	m_H = 0.0;
	m_X = 0.0;
	m_Y = 0.0;
	m_Z = 0.0;
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_TransType = 0;
	//}}AFX_DATA_INIT
}


void CDlgBLHXYZ::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBLHXYZ)
	DDX_Text(pDX, IDC_EDIT1, m_csParameters);
	DDV_MaxChars(pDX, m_csParameters, 1000);
	DDX_Text(pDX, IDC_EDIT_B, m_B);
	DDV_MinMaxDouble(pDX, m_B, -90., 90.);
	DDX_Text(pDX, IDC_EDIT_L, m_L);
	DDV_MinMaxDouble(pDX, m_L, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_H, m_H);
	DDX_Text(pDX, IDC_EDIT_X, m_X);
	DDX_Text(pDX, IDC_EDIT_Y, m_Y);
	DDX_Text(pDX, IDC_EDIT_Z, m_Z);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Radio(pDX, IDC_RADIO1, m_TransType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgBLHXYZ, CDialog)
	//{{AFX_MSG_MAP(CDlgBLHXYZ)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_Btn_XYZ2BLH, OnBtnXYZ2BLH)
	ON_BN_CLICKED(IDC_Btn_BLH2XYZ, OnBtnBLH2XYZ)
	ON_BN_CLICKED(IDC_Btn_Open, OnBtnOpen)
	ON_BN_CLICKED(IDC_BUTTON_Save, OnBUTTONSave)
	ON_BN_CLICKED(IDC_Btn_BLH2XYZ_File, OnBtnBLH2XYZFile)
	ON_BN_CLICKED(IDC_Btn_XYZ2BLH_File, OnBtnXYZ2BLHFile)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgBLHXYZ message handlers

BOOL CDlgBLHXYZ::OnInitDialog() 
{
	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("%s   Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);

	SetEnableStatus(m_TransType);
	
	CDialog::OnInitDialog();

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgBLHXYZ::OnButton1() 
{
	UpdateData(1);
	CDlgSphere dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleIn;
	dlg.m_AngleOut=m_AngleOut;
	if(dlg.DoModal() != IDOK) return;
	m_Sphere=dlg.m_Sphere;
	m_AngleIn=dlg.m_AngleIn;
	m_AngleOut=dlg.m_AngleOut;

	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("%s   Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);

	UpdateData(0);
}

void CDlgBLHXYZ::OnBtnXYZ2BLH() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	C3DpointExchange::XYZ2BLH(m_X,m_Y,m_Z,&m_B,&m_L,&m_H,m_AngleOut,&m_Sphere);
	CString strtemp;
	strtemp.Format("%.10lf", m_B);
	m_B = atof(strtemp);
	strtemp.Format("%.10lf", m_L);
	m_L = atof(strtemp);
	strtemp.Format("%13.4lf", m_H);
	m_H = atof(strtemp);
	UpdateData(0);
}

void CDlgBLHXYZ::OnBtnBLH2XYZ() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	C3DpointExchange::BLH2XYZ(m_B,m_L,m_H,&m_X,&m_Y,&m_Z,m_AngleIn,&m_Sphere);
	CString strtemp;
	strtemp.Format("%13.4lf", m_X);
	m_X = atof(strtemp);
	strtemp.Format("%13.4lf", m_Y);
	m_Y = atof(strtemp);
	strtemp.Format("%13.4lf", m_Z);
	m_Z = atof(strtemp);
	UpdateData(0);
}

void CDlgBLHXYZ::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
}

void CDlgBLHXYZ::OnBUTTONSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);	
}

void CDlgBLHXYZ::OnBtnBLH2XYZFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1,a;
	double b,c,d,b1,c1,d1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf",a,&b,&c,&d) < 4) continue;
	
		C3DpointExchange::BLH2XYZ(b,c,d,&b1,&c1,&d1,m_AngleIn,&m_Sphere);

		m_fileW.WriteString(a);
		m_fileW.WriteString(" ");

		str1.Format("%13.4lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",d1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);

}

void CDlgBLHXYZ::OnBtnXYZ2BLHFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1,a;
	double b,c,d,b1,c1,d1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf",a,&b,&c,&d) < 4) continue;


		C3DpointExchange::XYZ2BLH(b,c,d,&b1,&c1,&d1,m_AngleOut,&m_Sphere);

		m_fileW.WriteString(a);
		m_fileW.WriteString(" ");

		str1.Format("%16.10lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%16.10lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",d1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgBLHXYZ::OnRadio1() 
{
	UpdateData();
	SetEnableStatus(m_TransType);
}

void CDlgBLHXYZ::OnRadio2() 
{
	UpdateData();
	SetEnableStatus(m_TransType);
}

void CDlgBLHXYZ::SetEnableStatus(int iType)
{

		GetDlgItem(IDC_Btn_BLH2XYZ)->EnableWindow(iType == 0);
		GetDlgItem(IDC_Btn_BLH2XYZ_File)->EnableWindow(iType == 0);
		
		((CEdit*)GetDlgItem(IDC_EDIT_B))->SetReadOnly(iType != 0);
		((CEdit*)GetDlgItem(IDC_EDIT_L))->SetReadOnly(iType != 0);
		((CEdit*)GetDlgItem(IDC_EDIT_H))->SetReadOnly(iType != 0);

		GetDlgItem(IDC_Btn_XYZ2BLH)->EnableWindow(iType == 1);
		GetDlgItem(IDC_Btn_XYZ2BLH_File)->EnableWindow(iType == 1);
		((CEdit*)GetDlgItem(IDC_EDIT_X))->SetReadOnly(iType != 1);
		((CEdit*)GetDlgItem(IDC_EDIT_Y))->SetReadOnly(iType != 1);
		((CEdit*)GetDlgItem(IDC_EDIT_Z))->SetReadOnly(iType != 1);
}
