// DlgGaussChangeZone.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgSphere.h"
#include "DlgGaussChangeZone.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGaussChangeZone dialog


CDlgGaussChangeZone::CDlgGaussChangeZone(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGaussChangeZone::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGaussChangeZone)
	m_csParameters = _T("");
	m_x1 = 0.0;
	m_x2 = 0.0;
	m_y1 = 0.0;
	m_y2 = 0.0;
	m_h2 = 0.0;
	m_h1 = 0.0;
	m_midL1 = 0.0;
	m_midL2 = 0.0;
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_originY = 500000.0;
	m_ProType = 0;
	//}}AFX_DATA_INIT
}


void CDlgGaussChangeZone::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGaussChangeZone)
	DDX_Text(pDX, IDC_EDIT_Para, m_csParameters);
	DDX_Text(pDX, IDC_EDIT_x1, m_x1);
	DDX_Text(pDX, IDC_EDIT_x2, m_x2);
	DDX_Text(pDX, IDC_EDIT_y1, m_y1);
	DDX_Text(pDX, IDC_EDIT_y2, m_y2);
	DDX_Text(pDX, IDC_h2, m_h2);
	DDX_Text(pDX, IDC_EDIT_h1, m_h1);
	DDX_Text(pDX, IDC_EDIT_midL1, m_midL1);
	DDV_MinMaxDouble(pDX, m_midL1, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_midL2, m_midL2);
	DDV_MinMaxDouble(pDX, m_midL2, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Text(pDX, IDC_EDIT_originY, m_originY);
	DDX_CBIndex(pDX, IDC_COMBO1, m_ProType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgGaussChangeZone, CDialog)
	//{{AFX_MSG_MAP(CDlgGaussChangeZone)
	ON_BN_CLICKED(IDC_Btn_ParaChange, OnBtnParaChange)
	ON_BN_CLICKED(IDC_Btn_ChangeZone, OnBtnChangeZone)
	ON_BN_CLICKED(IDC_Btn_Open, OnBtnOpen)
	ON_BN_CLICKED(IDC_BUTTON_Save, OnBUTTONSave)
	ON_BN_CLICKED(IDC_Btn_ChangeZone_File, OnBtnChangeZoneFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGaussChangeZone message handlers

void CDlgGaussChangeZone::OnBtnParaChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	CDlgSphere dlg;
	dlg.m_Sphere=m_Sphere;
	if(dlg.DoModal() != IDOK) return;
	m_Sphere=dlg.m_Sphere;

	CString cssphere;
	cssphere=m_Sphere.GetSpherePara();
	m_csParameters.Format("%s",cssphere);

	UpdateData(0);
	
}

BOOL CDlgGaussChangeZone::OnInitDialog() 
{
	
	// TODO: Add extra initialization here
	CString cssphere;
	cssphere=m_Sphere.GetSpherePara();
	m_csParameters.Format("%s",cssphere);

	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgGaussChangeZone::OnBtnChangeZone() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
//	double m_tmpx,m_tmpy;
//	if (m_ProType==1)
//	{
//		m_tmpx=m_x1;
//		m_tmpy=m_y1;
//		m_x1=m_x1/0.99960;
//		m_y1=m_y1/0.99960;
//	}

	if (!(C3DpointExchange::GaussChangeZone(m_x1,m_y1,m_h1,&m_x2,&m_y2,&m_h2,m_midL1,m_midL2,m_originY,&m_Sphere,m_ProType)))
	{
		return;
	}
//	if (m_ProType==1)
//	{
//		m_x1=m_tmpx;
//		m_y1=m_tmpy;
//		m_x2=m_x2*0.99960;
//		m_y2=m_y2*0.99960;
//	}
	CString strtemp;
	strtemp.Format("%13.4lf", m_x2);
	m_x2 = atof(strtemp);
	strtemp.Format("%13.4lf", m_y2);
	m_y2 = atof(strtemp);
	strtemp.Format("%13.4lf", m_h2);
	m_h2 = atof(strtemp);
	UpdateData(0);
	
}

void CDlgGaussChangeZone::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgGaussChangeZone::OnBUTTONSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);	
	
}

void CDlgGaussChangeZone::OnBtnChangeZoneFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1,a;
	double b,c,d,b1,c1,d1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf",a,&b,&c,&d) < 4) continue;

//		if (m_ProType==1)
//		{
//			b/=0.9996;
//			c/=0.9996;
//		}

		C3DpointExchange::GaussChangeZone(b,c,d,&b1,&c1,&d1,m_midL1,m_midL2,m_originY,&m_Sphere,m_ProType);

//		if (m_ProType==1)
//		{
//			b1*=0.9996;
//			c1*=0.9996;
//		}
		m_fileW.WriteString(a);
		m_fileW.WriteString(" ");

		str1.Format("%13.4lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",d1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}
