// DlgGaussProjection.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "GeoGlobal.h"
#include "DlgSphere.h"
#include "DlgGaussProjection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGaussProjection dialog


CDlgGaussProjection::CDlgGaussProjection(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGaussProjection::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGaussProjection)
	m_B = 0.0;
	m_L = 0.0;
	m_H = 0.0;
	m_x = 0.0;
	m_y = 0.0;
	m_h = 0.0;
	m_csParameters = _T("");
	m_midL = 0.0;
	m_originY = 500000.0;
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_TransType = 0;
	m_ProType = 0;
	//}}AFX_DATA_INIT
}


void CDlgGaussProjection::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGaussProjection)
	DDX_Text(pDX, IDC_EDIT_B, m_B);
	DDV_MinMaxDouble(pDX, m_B, -90., 90.);
	DDX_Text(pDX, IDC_EDIT_L, m_L);
	DDV_MinMaxDouble(pDX, m_L, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_H, m_H);
	DDX_Text(pDX, IDC_EDIT_X, m_x);
	DDX_Text(pDX, IDC_EDIT_Y, m_y);
	DDX_Text(pDX, IDC_h, m_h);
	DDX_Text(pDX, IDC_EDIT_Para, m_csParameters);
	DDX_Text(pDX, IDC_EDIT_midL, m_midL);
	DDV_MinMaxDouble(pDX, m_midL, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_originY, m_originY);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Radio(pDX, IDC_RADIO1, m_TransType);
	DDX_CBIndex(pDX, IDC_COMBO1, m_ProType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgGaussProjection, CDialog)
	//{{AFX_MSG_MAP(CDlgGaussProjection)
	ON_BN_CLICKED(IDC_Btn_ParaChange, OnBtnParaChange)
	ON_BN_CLICKED(IDC_Btn_BLH2xyh, OnBtnBLH2xyh)
	ON_BN_CLICKED(IDC_Btn_xyh2BLH, OnBtnxyh2BLH)
	ON_BN_CLICKED(IDC_Btn_Open, OnBtnOpen)
	ON_BN_CLICKED(IDC_BUTTON_Save, OnBUTTONSave)
	ON_BN_CLICKED(IDC_Btn_BLH2xyh_File, OnBtnBLH2xyhFile)
	ON_BN_CLICKED(IDC_Btn_xyh2BLH_File, OnBtnxyh2BLHFile)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGaussProjection message handlers

void CDlgGaussProjection::OnBtnParaChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	CDlgSphere dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleIn;
	dlg.m_AngleOut=m_AngleOut;
	if(dlg.DoModal() != IDOK) return;
	m_Sphere=dlg.m_Sphere;
	m_AngleIn=dlg.m_AngleIn;
	m_AngleOut=dlg.m_AngleOut;

	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("%s   Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);

	UpdateData(0);
	
}

BOOL CDlgGaussProjection::OnInitDialog() 
{
	// TODO: Add extra initialization here
	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("%s   Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);
	
	SetEnableStatus(m_TransType);

	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgGaussProjection::OnBtnBLH2xyh() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	CoordBLH m_BLH;
	Coordxyh m_xyh;
	m_BLH.B=m_B;
	m_BLH.L=m_L;
	m_BLH.H=m_H;
	double tmpL;
	tmpL=::AngleTransfer(m_L,m_AngleIn,2);
	if (((tmpL-m_midL)<(-3))||((tmpL-m_midL)>3))
	{
		AfxMessageBox("ͶӰ㾭3ȣܻϴ");
	}
	C3DpointExchange::BLH2xyh(m_BLH,&m_xyh,m_AngleIn,m_midL,m_originY,&m_Sphere,m_ProType);
	m_x=m_xyh.x;
	m_y=m_xyh.y;
	m_h=m_xyh.h;
//	if (m_ProType==1)
//	{
//		m_x=0.9996*m_x;
//		m_y=0.9996*m_y;
//	}
	CString strtemp;
	strtemp.Format("%13.4lf", m_x);
	m_x = atof(strtemp);
	strtemp.Format("%13.4lf", m_y);
	m_y = atof(strtemp);
	strtemp.Format("%13.4lf", m_h);
	m_h = atof(strtemp);
	UpdateData(0);
	
}

void CDlgGaussProjection::OnBtnxyh2BLH() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	CoordBLH m_BLH;
	Coordxyh m_xyh;
	m_xyh.x=m_x;
	m_xyh.y=m_y;
	m_xyh.h=m_h;
//	if (m_ProType==1)
//	{
//		m_xyh.x=m_xyh.x/0.99960;
//		m_xyh.y=m_xyh.y/0.99960;
//	}
	//C3DpointExchange pe;
	//pe.xyh2BLHWithL0(m_x,m_y,m_h,0,0,&m_BLH);
	C3DpointExchange::xyh2BLH(m_xyh,&m_BLH,m_AngleOut,m_midL,m_originY,&m_Sphere,m_ProType);
	m_B=m_BLH.B;
	m_L=m_BLH.L;
	m_H=m_BLH.H;
	CString strtemp;
	strtemp.Format("%.10lf", m_B);
	m_B = atof(strtemp);
	strtemp.Format("%.10lf", m_L);
	m_L = atof(strtemp);
	strtemp.Format("%13.4lf", m_H);
	m_H = atof(strtemp);
	UpdateData(0);
	
}

void CDlgGaussProjection::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgGaussProjection::OnBUTTONSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);	
	
}

void CDlgGaussProjection::OnBtnBLH2xyhFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1,a;
	double b,c,d,b1,c1,d1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf",a,&b,&c,&d) < 4) continue;
		CoordBLH m_BLH;
		Coordxyh m_xyh;
		m_BLH.B=b;
		m_BLH.L=c;
		m_BLH.H=d;
		C3DpointExchange::BLH2xyh(m_BLH,&m_xyh,m_AngleIn,m_midL,m_originY,&m_Sphere,m_ProType);
		b1=m_xyh.x;
		c1=m_xyh.y;
		d1=m_xyh.h;
//		if (m_ProType==1)
//		{
//			b1=0.9996*b1;
//			c1=0.9996*c1;
//		}
		m_fileW.WriteString(a);
		m_fileW.WriteString(" ");

		str1.Format("%13.4lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",d1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgGaussProjection::OnBtnxyh2BLHFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1,a;
	double b,c,d,b1,c1,d1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf",a,&b,&c,&d) < 4) continue;
		CoordBLH m_BLH;
		Coordxyh m_xyh;
		m_xyh.x=b;
		m_xyh.y=c;
		m_xyh.h=d;
		if (m_ProType==1)
		{
			m_xyh.x=m_xyh.x/0.99960;
			m_xyh.y=m_xyh.y/0.99960;
		}
		C3DpointExchange::xyh2BLH(m_xyh,&m_BLH,m_AngleOut,m_midL,m_originY,&m_Sphere,m_ProType);
		b1=m_BLH.B;
		c1=m_BLH.L;
		d1=m_BLH.H;
		m_fileW.WriteString(a);
		m_fileW.WriteString(" ");

		str1.Format("%16.10lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%16.10lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%13.4lf",d1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgGaussProjection::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	SetEnableStatus(m_TransType);
	
}

void CDlgGaussProjection::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	SetEnableStatus(m_TransType);
	
}


void CDlgGaussProjection::SetEnableStatus(int iType)
{
	GetDlgItem(IDC_Btn_BLH2xyh)->EnableWindow(iType == 0);
	GetDlgItem(IDC_Btn_BLH2xyh_File)->EnableWindow(iType == 0);
	
	((CEdit*)GetDlgItem(IDC_EDIT_B))->SetReadOnly(iType != 0);
	((CEdit*)GetDlgItem(IDC_EDIT_L))->SetReadOnly(iType != 0);
	((CEdit*)GetDlgItem(IDC_EDIT_H))->SetReadOnly(iType != 0);

	GetDlgItem(IDC_Btn_xyh2BLH)->EnableWindow(iType == 1);
	GetDlgItem(IDC_Btn_xyh2BLH_File)->EnableWindow(iType == 1);
	
	((CEdit*)GetDlgItem(IDC_EDIT_X))->SetReadOnly(iType != 1);
	((CEdit*)GetDlgItem(IDC_EDIT_Y))->SetReadOnly(iType != 1);
	((CEdit*)GetDlgItem(IDC_h))->SetReadOnly(iType != 1);

}
