// DlgGeoSol.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "GeoGlobal.h"
#include "DlgSphere.h"
#include "DlgGeoSol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgGeoSol dialog


CDlgGeoSol::CDlgGeoSol(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgGeoSol::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgGeoSol)
	m_csParameters = _T("");
	m_A = 0.0;
	m_B1 = 0.0;
	m_B2 = 0.0;
	m_L1 = 0.0;
	m_L2 = 0.0;
	m_S = 0.0;
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_TransType = 0;
	//}}AFX_DATA_INIT
}


void CDlgGeoSol::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgGeoSol)
	DDX_Text(pDX, IDC_EDIT_Para, m_csParameters);
	DDX_Text(pDX, IDC_EDIT_A, m_A);
	DDX_Text(pDX, IDC_EDIT_B1, m_B1);
	DDV_MinMaxDouble(pDX, m_B1, -90., 90.);
	DDX_Text(pDX, IDC_EDIT_B2, m_B2);
	DDV_MinMaxDouble(pDX, m_B2, -90., 90.);
	DDX_Text(pDX, IDC_EDIT_L1, m_L1);
	DDV_MinMaxDouble(pDX, m_L1, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_L2, m_L2);
	DDV_MinMaxDouble(pDX, m_L2, -180., 180.);
	DDX_Text(pDX, IDC_EDIT_S, m_S);
	DDV_MinMaxDouble(pDX, m_S, 0., 1.e+029);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Radio(pDX, IDC_RADIO1, m_TransType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgGeoSol, CDialog)
	//{{AFX_MSG_MAP(CDlgGeoSol)
	ON_BN_CLICKED(IDC_Btn_ParaChange, OnBtnParaChange)
	ON_BN_CLICKED(IDC_Btn_BL2SA, OnBtnBL2SA)
	ON_BN_CLICKED(IDC_Btn_SA2BL, OnBtnSA2BL)
	ON_BN_CLICKED(IDC_Btn_Open, OnBtnOpen)
	ON_BN_CLICKED(IDC_Btn_Save, OnBtnSave)
	ON_BN_CLICKED(IDC_Btn_BL2SA_File, OnBtnBL2SAFile)
	ON_BN_CLICKED(IDC_Btn_SA2BL_File, OnBtnSA2BLFile)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgGeoSol message handlers

BOOL CDlgGeoSol::OnInitDialog() 
{
	// TODO: Add extra initialization here

	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("%s   Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);

	SetEnableStatus(m_TransType);
	
	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgGeoSol::OnBtnParaChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	CDlgSphere dlg;
	dlg.m_Sphere=m_Sphere;
	dlg.m_AngleIn=m_AngleIn;
	dlg.m_AngleOut=m_AngleOut;
	if(dlg.DoModal() != IDOK) return;
	m_Sphere=dlg.m_Sphere;
	m_AngleIn=dlg.m_AngleIn;
	m_AngleOut=dlg.m_AngleOut;

	CString cssphere,csAngleTypeIn,csAngleTypeOut;
	cssphere=m_Sphere.GetSpherePara();
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("%s   Ƕȵλ:  (%s)  ,    (%s)",cssphere,csAngleTypeIn,csAngleTypeOut);

	UpdateData(0);
	
}

void CDlgGeoSol::OnBtnBL2SA() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	GeodeticSolution::GeoBL2SA(m_B1,m_L1,m_B2,m_L2,&m_S,&m_A,m_AngleIn,m_AngleOut,&m_Sphere);
	CString strtemp;
	strtemp.Format("%13.5lf", m_S);
	m_S = atof(strtemp);
	strtemp.Format("%16.10lf", m_A);
	m_A = atof(strtemp);
	UpdateData(0);
}

void CDlgGeoSol::OnBtnSA2BL() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	GeodeticSolution::GeoSA2BL(m_B1,m_L1,m_S,m_A,&m_B2,&m_L2,m_AngleIn,m_AngleOut,&m_Sphere);
	CString strtemp;
	strtemp.Format("%16.10lf", m_B2);
	m_B2 = atof(strtemp);
	strtemp.Format("%16.10lf", m_L2);
	m_L2 = atof(strtemp);
	UpdateData(0);
	
}

void CDlgGeoSol::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
}

void CDlgGeoSol::OnBtnSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);	
	
}

void CDlgGeoSol::OnBtnBL2SAFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_string,str1;
	double b=0,c=0,d=0,e=0,b1=0,c1=0;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_string))
	{
		m_string.TrimLeft();
		m_string.TrimRight();

		if(m_string.GetLength() < 7 ) continue;

		if(sscanf(m_string,"%lf %lf %lf %lf",&b,&c,&d,&e) < 4) continue;
	
		GeodeticSolution::GeoBL2SA(b,c,d,e,&b1,&c1,m_AngleIn,m_AngleOut,&m_Sphere);
		str1.Format("%13.5lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%16.10lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgGeoSol::OnBtnSA2BLFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1;
	double b,c,d,e,b1,c1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%lf %lf %lf %lf",&b,&c,&d,&e) < 4) continue;

		GeodeticSolution::GeoSA2BL(b,c,d,e,&b1,&c1,m_AngleIn,m_AngleOut,&m_Sphere);

		str1.Format("%16.10lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%16.10lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgGeoSol::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	SetEnableStatus(m_TransType);
	
}

void CDlgGeoSol::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	SetEnableStatus(m_TransType);
	
}

void CDlgGeoSol::SetEnableStatus(int iType)
{
	GetDlgItem(IDC_Btn_BL2SA)->EnableWindow(iType == 0);
	GetDlgItem(IDC_Btn_BL2SA_File)->EnableWindow(iType == 0);
	
	((CEdit*)GetDlgItem(IDC_EDIT_B2))->SetReadOnly(iType != 0);
	((CEdit*)GetDlgItem(IDC_EDIT_L2))->SetReadOnly(iType != 0);

	GetDlgItem(IDC_Btn_SA2BL)->EnableWindow(iType == 1);
	GetDlgItem(IDC_Btn_SA2BL_File)->EnableWindow(iType == 1);
	
	((CEdit*)GetDlgItem(IDC_EDIT_S))->SetReadOnly(iType != 1);
	((CEdit*)GetDlgItem(IDC_EDIT_A))->SetReadOnly(iType != 1);

}
