// DlgPlanexySA.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgPlanexySA.h"
#include "DlgSphere.h"
#include "GeoGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgPlanexySA dialog


CDlgPlanexySA::CDlgPlanexySA(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPlanexySA::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPlanexySA)
	m_A = 0.0;
	m_csParameters = _T("");
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_S = 0.0;
	m_x1 = 0.0;
	m_x2 = 0.0;
	m_y1 = 0.0;
	m_y2 = 0.0;
	m_TransType = 0;
	//}}AFX_DATA_INIT

}


void CDlgPlanexySA::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPlanexySA)
	DDX_Text(pDX, IDC_EDIT_A, m_A);
	DDX_Text(pDX, IDC_EDIT_Para, m_csParameters);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Text(pDX, IDC_EDIT_S, m_S);
	DDV_MinMaxDouble(pDX, m_S, 0., 1.e+020);
	DDX_Text(pDX, IDC_EDIT_x1, m_x1);
	DDX_Text(pDX, IDC_EDIT_x2, m_x2);
	DDX_Text(pDX, IDC_EDIT_y1, m_y1);
	DDX_Text(pDX, IDC_EDIT_y2, m_y2);
	DDX_Radio(pDX, IDC_RADIO1, m_TransType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgPlanexySA, CDialog)
	//{{AFX_MSG_MAP(CDlgPlanexySA)
	ON_BN_CLICKED(IDC_Btn_ParaChange, OnBtnParaChange)
	ON_BN_CLICKED(IDC_Btn_xy2SA, OnBtnxy2SA)
	ON_BN_CLICKED(IDC_Btn_SA2xy, OnBtnSA2xy)
	ON_BN_CLICKED(IDC_Btn_xy2SA_File, OnBtnxy2SAFile)
	ON_BN_CLICKED(IDC_Btn_SA2xy_File, OnBtnSA2xyFile)
	ON_BN_CLICKED(IDC_Btn_Open, OnBtnOpen)
	ON_BN_CLICKED(IDC_Btn_Save, OnBtnSave)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPlanexySA message handlers

void CDlgPlanexySA::OnBtnParaChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	CDlgSphere dlg;
	dlg.m_AngleIn=m_AngleIn;
	dlg.m_AngleOut=m_AngleOut;
	if(dlg.DoModal() != IDOK) return;
	m_AngleIn=dlg.m_AngleIn;
	m_AngleOut=dlg.m_AngleOut;

	CString csAngleTypeIn,csAngleTypeOut;
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("Ƕȵλ:  (%s)  ,    (%s)",csAngleTypeIn,csAngleTypeOut);

	UpdateData(0);
	
}

void CDlgPlanexySA::OnBtnxy2SA() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	C3DpointExchange::Geoxy2SA(m_x1,m_y1,m_x2,m_y2,&m_S,&m_A,m_AngleOut,m_AngleIn);
	CString strtemp;
	strtemp.Format("%20.10lf", m_S);
	m_S = atof(strtemp);
	strtemp.Format("%lf", m_A);
	m_A = atof(strtemp);
	UpdateData(0);
	
}

void CDlgPlanexySA::OnBtnSA2xy() 
{
	// TODO: Add your control notification handler code here
	UpdateData(1);
	C3DpointExchange::GeoSA2xy(m_x1,m_y1,m_S,m_A,&m_x2,&m_y2,m_AngleIn,m_AngleOut);
	CString strtemp;
	strtemp.Format("%16.10lf", m_x2);
	m_x2 = atof(strtemp);
	strtemp.Format("%16.10lf", m_y2);
	m_y2 = atof(strtemp);
	UpdateData(0);
	
}

void CDlgPlanexySA::OnBtnxy2SAFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1;
	double b,c,d,e,b1,c1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%lf %lf %lf %lf",&b,&c,&d,&e) < 4) continue;


		C3DpointExchange::Geoxy2SA(b,c,d,e,&b1,&c1,m_AngleOut,m_AngleIn);

		str1.Format("%20.10lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%16.10lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgPlanexySA::OnBtnSA2xyFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_stringRead,str1;
	double b,c,d,e,b1,c1;
	CStdioFile m_fileR,m_fileW;
	if(!m_fileR.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_fileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    while(m_fileR.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%lf %lf %lf %lf",&b,&c,&d,&e) < 4) continue;


		C3DpointExchange::GeoSA2xy(b,c,d,e,&b1,&c1,m_AngleIn,m_AngleOut);

		str1.Format("%16.10lf",b1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString(" ");
		str1.Format("%16.10lf",c1);
		m_fileW.WriteString(str1);
		m_fileW.WriteString("\n");
	}
	m_fileR.Close();
	m_fileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgPlanexySA::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgPlanexySA::OnBtnSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);	
	
}

BOOL CDlgPlanexySA::OnInitDialog() 
{
	
	// TODO: Add extra initialization here
	CString csAngleTypeIn,csAngleTypeOut;
	csAngleTypeIn=GetCsAngleType(m_AngleIn);
	csAngleTypeOut=GetCsAngleType(m_AngleOut);
	m_csParameters.Format("Ƕȵλ:  (%s)  ,    (%s)",csAngleTypeIn,csAngleTypeOut);

	SetEnableStatus(m_TransType);

	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgPlanexySA::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	SetEnableStatus(m_TransType);
	
}

void CDlgPlanexySA::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	SetEnableStatus(m_TransType);
	
}

void CDlgPlanexySA::SetEnableStatus(int iType)
{
	GetDlgItem(IDC_Btn_xy2SA)->EnableWindow(iType == 0);
	GetDlgItem(IDC_Btn_xy2SA_File)->EnableWindow(iType == 0);
	
	((CEdit*)GetDlgItem(IDC_EDIT_x2))->SetReadOnly(iType != 0);
	((CEdit*)GetDlgItem(IDC_EDIT_y2))->SetReadOnly(iType != 0);

	GetDlgItem(IDC_Btn_SA2xy)->EnableWindow(iType == 1);
	GetDlgItem(IDC_Btn_SA2xy_File)->EnableWindow(iType == 1);
	((CEdit*)GetDlgItem(IDC_EDIT_S))->SetReadOnly(iType != 1);
	((CEdit*)GetDlgItem(IDC_EDIT_A))->SetReadOnly(iType != 1);

}
