// DlgSphere.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgSphere.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSphere dialog


CDlgSphere::CDlgSphere(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSphere::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSphere)
	m_a = 0.0;
	m_rAlfa = 0.0;
	m_SphereType = -1;
	m_AngleIn = -1;
	m_AngleOut = -1;
	//}}AFX_DATA_INIT
}


void CDlgSphere::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSphere)
	DDX_Text(pDX, IDC_EDIT1, m_a);
	DDV_MinMaxDouble(pDX, m_a, 1000000., 10000000.);
	DDX_Text(pDX, IDC_EDIT2, m_rAlfa);
	DDV_MinMaxDouble(pDX, m_rAlfa, 2., 1000.);
	DDX_Radio(pDX, IDC_RADIO1, m_SphereType);
	DDX_CBIndex(pDX, IDC_COMBO1, m_AngleIn);
	DDX_CBIndex(pDX, IDC_COMBO2, m_AngleOut);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSphere, CDialog)
	//{{AFX_MSG_MAP(CDlgSphere)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSphere message handlers

void CDlgSphere::OnOK() 
{
	UpdateData(1);
	if(m_SphereType==0)
	{
		m_Sphere.SetSphereType(m_SphereType);
		m_Sphere.SetSpherePara(m_a,1.0/m_rAlfa);
	}
	CDialog::OnOK();
}

BOOL CDlgSphere::OnInitDialog() 
{
	m_Sphere.GetSpherePara(&m_a,&m_rAlfa,NULL,NULL,&m_SphereType);
	m_rAlfa=1.0/m_rAlfa;

	if(m_SphereType==0)
	{
		GetDlgItem(IDC_EDIT1)->EnableWindow(1);
		GetDlgItem(IDC_EDIT2)->EnableWindow(1);
	}
	else
	{
		GetDlgItem(IDC_EDIT1)->EnableWindow(0);
		GetDlgItem(IDC_EDIT2)->EnableWindow(0);
	}
	CDialog::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgSphere::OnRadio1() 
{

	CheckStatus();
}

void CDlgSphere::CheckStatus()
{
	UpdateData(1);
	if(m_SphereType==0)
	{
		GetDlgItem(IDC_EDIT1)->EnableWindow(1);
		GetDlgItem(IDC_EDIT2)->EnableWindow(1);
	}
	else
	{
		m_Sphere.SetSphereType(m_SphereType);
		m_Sphere.GetSpherePara(&m_a,&m_rAlfa);
		m_rAlfa=1.0/m_rAlfa;
		UpdateData(0);

		GetDlgItem(IDC_EDIT1)->EnableWindow(0);
		GetDlgItem(IDC_EDIT2)->EnableWindow(0);
	}
}

void CDlgSphere::OnRadio2() 
{
	CheckStatus();
}

void CDlgSphere::OnRadio3() 
{
	CheckStatus();
}

void CDlgSphere::OnRadio4() 
{
	CheckStatus();
}
