/////////////////////////////////////////////////////////////////////////////
// ƽгþ
#include "stdafx.h"
#include "GeoMath.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CMatrix_Adjust::CMatrix_Adjust()
{
	//initial the CMatrix_Adjust class.
}
CMatrix_Adjust::~CMatrix_Adjust()
{
}

long double ** CMatrix_Adjust::TwoArrayAlloc(int r,int c)
{
	long double  *x, **y;
	int n;

	x=(long double *)calloc(r*c,sizeof(long double));
	if(x==NULL)
    {
		AfxMessageBox("Failure in memory applying!");  
		exit(0);
    }

	y=(long double **)calloc(r,sizeof(long double *));
	for(n=0;n<=r-1;++n)
		y[n]=&x[c*n];
	return(y);		//???????
}

void CMatrix_Adjust::TwoArrayFree(long double **x)
{
	free(x[0]);
	free(x);
}

int CMatrix_Adjust::InverseMatrix(int n,long double **a,long double **b)
{
	int *is,*js,i,j,k,l,u,v;
    double d,p;
    is = (int *)malloc(n*sizeof(int));
    js = (int *)malloc(n*sizeof(int));
	double *c = new double[n*n];
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			c[i*n+j] = a[i][j];			
    for (k=0; k<=n-1; k++)
      { d=0.0;
        for (i=k; i<=n-1; i++)
        for (j=k; j<=n-1; j++)
          { l=i*n+j; p=fabs(c[l]);
            if (p>d) { d=p; is[k]=i; js[k]=j;}
          }
        if (d+1.0==1.0)
          { free(is); free(js); delete[] c;printf("err**not inv\n");
            return(0);
          }
        if (is[k]!=k)
          for (j=0; j<=n-1; j++)
            { u=k*n+j; v=is[k]*n+j;
              p=c[u]; c[u]=c[v]; c[v]=p;
            }
        if (js[k]!=k)
          for (i=0; i<=n-1; i++)
            { u=i*n+k; v=i*n+js[k];
              p=c[u]; c[u]=c[v]; c[v]=p;
            }
        l=k*n+k;
        c[l]=1.0/c[l];
        for (j=0; j<=n-1; j++)
          if (j!=k)
            { u=k*n+j; c[u]=c[u]*c[l];}
        for (i=0; i<=n-1; i++)
          if (i!=k)
            for (j=0; j<=n-1; j++)
              if (j!=k)
                { u=i*n+j;
                  c[u]=c[u]-c[i*n+k]*c[k*n+j];
                }
        for (i=0; i<=n-1; i++)
          if (i!=k)
            { u=i*n+k; c[u]=-c[u]*c[l];}
      }
    for (k=n-1; k>=0; k--)
      { if (js[k]!=k)
          for (j=0; j<=n-1; j++)
            { u=k*n+j; v=js[k]*n+j;
              p=c[u]; c[u]=c[v]; c[v]=p;
            }
        if (is[k]!=k)
          for (i=0; i<=n-1; i++)
            { u=i*n+k; v=i*n+is[k];
              p=c[u]; c[u]=c[v]; c[v]=p;
            }
      }
    free(is); free(js);
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			b[i][j] = c[i*n+j];
	delete[] c;
    return(1);

}

//
//     
//     A    ԭʼ  ΪNУNеĿ
//
//     N  -- BĽ   д˺A Ϊԭ
//
bool CMatrix_Adjust::MatrixInv(long double *a,int n)
{
	int *is,*js,i,j,k,l,u,v;
	long double d,p;
	is=(int *)malloc(n*sizeof(int));
	js=(int *)malloc(n*sizeof(int));

	if(is == NULL || js == NULL ||a == NULL) 
		return false;
	for(k=0;k<=n-1;k++)
	{
		d=0.0;
		for(i=k;i<=n-1;i++)
			for(j=k;j<=n-1;j++)
			{
				l=i*n+j;
				p=fabs(a[l]);
				if(p>d)  //ԪطŵԽ
				{   d=p;
					is[k]=i;
					js[k]=j;
				}
			}
	   if(d+1.0==1.0)   //жԽϵԪǲΪ0
	   { 
		    	free(is);
				free(js);
				return false;
		}
	    if(is[k]!=k)
		for(j=0;j<=n-1;j++)
		{
			u=k*n+j;
			v=is[k]*n+j;
			p=a[u];
			a[u]=a[v];
			a[v]=p;
		}
		if(js[k]!=k)
		  for(i=0;i<=n-1;i++)
		  {
			u=i*n+k; v=i*n+js[k];
			p=a[u]; a[u]=a[v]; a[v]=p;
		  }
		l=k*n+k;
		a[l]=1.0/a[l];
		for(j=0;j<=n-1;j++)
		  if(j!=k)
		  {
		   u=k*n+j; a[u]=a[u]*a[l];
		  }
		for(i=0;i<=n-1;i++)
		{
			if(i!=k)
		     for(j=0;j<=n-1;j++)
			   if(j!=k)
			   {
		    	 u=i*n+j;
			     a[u]=a[u]-a[i*n+k]*a[k*n+j];}
		}
		for(i=0;i<=n-1;i++)
			if(i!=k)
				{
					u=i*n+k; a[u]=-a[u]*a[l];
				}
		
		}
		for(k=n-1;k>=0;k--)
		{
			if(js[k]!=k)
		     	for(j=0;j<=n-1;j++)
				{
				   u=k*n+j; v=js[k]*n+j;
					p=a[u]; a[u]=a[v]; a[v]=p;
				}
			if(is[k]!=k)
			   for(i=0;i<=n-1;i++)
			   {
				  u=i*n+k; v=i*n+is[k];
				  p=a[u]; a[u]=a[v];a[v]=p;
				}
		}

		free(is);free(js);
		return true;
	
}

/*
ܣ
*/
void  CMatrix_Adjust::MatrixProduct(long double **A,int m,int n,long double *B,long double *C)
//A(m*n) *B(n*1) = C(m*1)
{

	for(int i=0;i<m;i++)
	{
		*(C+i)=0;
		for(int j=0;j<n;j++)
			*(C+i)+=(*(*(A+i)+j))*(*(B+j));
	}
}
//
//     ĳ˻ C=A*B
//     AB ԭʼ  ΪMAУNAкMBNBеľ
//     C      õ MA  NB еľ
//
//     MA -- A
//     NA -- A
//
//     MB -- B
//     NB -- B
//
bool CMatrix_Adjust::MatrixMulti(long double *A,long double *B,long double *C,int MA,int NA,int MB,int NB)
{
	int i,j,k;
	if(A==NULL||B==NULL||C==NULL)
		return false;
	if(NA!=MB) 
		return false;
	for(i=0;i<MA;i++)
	{
		for(j=0;j<NB;j++)
		{
			C[i*NB+j]=0;
            for(k = 0; k<NA;k++)
			{
			    C[i*NB+j] = C[i*NB+j]+ A[i*NA+k]*B[k*NB+j];
			}
		}
	}
	return true;
}

void CMatrix_Adjust::FormNormMatrix(long double **A,int m,int n,long double **NBB)
{
	for(int tem=0;tem<n;tem++)
		for(int met=0; met<n; met++)
			*(*(NBB+tem)+met)=0;
	for(int i=0;i<n;i++)
		for(int k=0;k<n;k++)
			for(int j=0;j<m;j++)
				*(*(NBB+i)+k)=*(*(NBB+i)+k)+(*(*(A+j)+i)) * (*(*(A+j)+k));
}

void  CMatrix_Adjust::FormFeMatrix(long double **B,int row,int col,long double *F,
                  long double *Fe)  //B(row,col),Fe(col*1)=B'*F
{
	int j;
	for( j=0;j<col;j++)
    {
		*(Fe+j)=0;
		for(int i=0;i<row;i++)
			*(Fe+j)+=*(*(B+i)+j)*(*(F+i));
     }
}

void  CMatrix_Adjust::FormFeMatrix(long double **A,int row,int col1,int **B,int col2,
							long double *F, long double *Fe)
{
	int j;
	for( j=0;j<col1;j++)
    {
		*(Fe+j)=0;
		for(int i=0;i<row;i++)
			*(Fe+j)+=*(*(A+i)+j)*(*(F+i));
     }
	for(j=0;j<col2;j++)
	{
		*(Fe+j+col1)=0;
		for(int i=0;i<row;i++)
			Fe[j+col1]+=B[i][j]*F[i];
	}
}
